const express= require("express");

const {  CakeModel } = require("../models/cakeModel");
const router = express.Router();

// http://localhost:3002/cakes?page=3&perPage=99999&sort=name&reverse=yes
router.get("/", async(req,res) => {
  let perPage = req.query.perPage ? Math.min( req.query.perPage,10) : 5;
  let page = req.query.page ? req.query.page-1 : 0; 
  let sort = req.query.sort || "_id";
  let reverse = req.query.reverse == "yes" ? 1 : -1
  try{
    let data = await CakeModel
    .find({})
    .limit(perPage)
    .skip(page * perPage)
    .sort({[sort]:reverse})
    res.json(data);
  }
  catch(err){
    console.log(err);
    res.status(500).json({msg_err:"There problem in server try again later"})
  }
})

// cakes/search?s=vanila
router.get("/search",async(req,res) => {
  try{
    let s = req.query.s;
    let searchExp = new RegExp(s,"i") 
    let data = await CakeModel
    .find({$or:[{name:searchExp},{info:searchExp}]})
    .limit(20);
    res.json(data);
  }
  catch(err){
    console.log(err);
    res.status(500).json({msg_err:"There problem in server try again later"})
  }
})

module.exports = router;